#include <LiquidCrystal.h>
#include <FastLED.h>

#define NUM_LEDS 4
#define LEDPIN 7
CRGB leds[NUM_LEDS];
int RedPin = A0; //Messeingang für den variablen Spannungsabgriff des "roten" Schiebepotentiometer
int GreenPin = A1; //Messeingang für den variablen Spannungsabgriff des "grünen" Schiebepotentiometer
int BluePin = A2; ////Messeingang für den variablen Spannungsabgriff des "blauen" Schiebepotentiometer
int Red = 0; //Erste Definition für den R-Wert im RGB-Wert
int Green = 0; //Erste Definition für den G-Wert im RGB-Wert
int Blue = 0; //Erste Definition für den B-Wert im RGB-Wert
const int rs = 12, en = 11, d4 = 5, d5 = 4, d6 = 3, d7 = 2; //Pinbelegung für den Anschluss des Displays
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

void setup() {
  FastLED.addLeds <WS2812B, LEDPIN,RGB>(leds, NUM_LEDS);
  lcd.begin(16,2);
}

void loop() {
  //Einlesen der Werte der Potentiometer und skalieren auf 0-255
  Red = map(analogRead(RedPin),0,1023,0,255); //Hier kann noch an der Feinabstimmung verändert werden. Sodass auf dem Display tatsächlich Werte von 0-255 angezeigt werden.
  Red=constrain(Red,0,255);
  Green = map(analogRead(GreenPin),0,1023,0,255); //Hier kann noch an der Feinabstimmung verändert werden. Sodass auf dem Display tatsächlich Werte von 0-255 angezeigt werden.
  Green= constrain (Green,0,255);
  Blue = map(analogRead(BluePin),0,1023,0,255); //Hier kann noch an der Feinabstimmung verändert werden. Sodass auf dem Display tatsächlich Werte von 0-255 angezeigt werden.
  Blue = constrain (Blue,0,255);
  
 
  //Ausgabe von Rot im LCD-Display
  lcd.setCursor(0,0);
  lcd.print("Rot");
  lcd.setCursor(0,1);
  //Leerzeichen, um Ausgabefehler bei kleineren Zahlen zu vermeiden
  if (Red<10) lcd.print(" ");
  if (Red<100) lcd.print(" ");
  lcd.print (Red);
  
  leds[0].setRGB(Red,0,0); //Ansteuerung der LED, die in der Grundfarbe rot leuchtet
  
  //Ausgabe von Grün
  lcd.setCursor(5,0);
  lcd.print("Gruen");
  lcd.setCursor(7,1);
  if (Green<10) lcd.print(" ");
  if (Green<100) lcd.print(" ");
  lcd.print (Green);
  leds[1].setRGB(0,Green,0); //Ansteuerung der LED, die in der Grundfarbe grün leuchtet
  
  //Ausgabe von Blau
  lcd.setCursor(12,0);
  lcd.print("Blau");
  lcd.setCursor(13,1);
  if (Blue<10) lcd.print(" ");
  if (Blue<100) lcd.print(" ");
  lcd.print (Blue);
  leds[2].setRGB(0,0,Blue); //Ansteuerung der LED, die in der Grundfarbe blau leuchtet

  //Mischfarbe Ausgeben
  leds[3].setRGB(Red,Green,Blue); //Ansteuerung der LED, die in der Mischfarbe leuchtet
  FastLED.show();   // Änderungen an LEDs weitergeben
  delay (100);      // Verzögerung

}
